// Craig S. Kaplan
//
// A simple spell checker that looks up words in an array.  Effective
// but slow.

String[] dict;

boolean isWord( String wd )
{
  for( int idx = 0; idx < dict.length; ++idx ) {
    if( dict[idx].equals( wd ) ) {
      return true;
    }
  }
  
  return false;
}

void setup()
{
  dict = loadStrings( "words.txt" );
  
  String[] lines = loadStrings( "carol.txt" );
  // 2. Join all the text into one long line.
  String text = join( lines, ' ' );
  // 3. Split things by spaces *and* punctuation.
  String[] words = splitTokens( text, " \n\t!?.,;:-\"_()/0123456789" );
  
  // Now we can easily iterate over each word in the text.
  for( int idx = 0; idx < words.length; ++idx ) {
    // Convert each word into lower case, so that words
    // at the starts of sentences can still be spell checked
    String word = words[idx].toLowerCase();
    
    if( !isWord( word ) ) {
      // Note that if we want to report the word, we report
      // the *original*, not the version converted to lower
      // case.
      println( words[idx] );
    }
  }
}